<template>
    <div ref="olMapDiv" id="map" class="map" :class="[store.state.showResults ? 'hidden': '']">
      <input v-if="isSearch" id="search-field" type="text" v-on:keyup.enter="searchCaptage" placeholder='Entrer un nom de lieu et presser "Enter"'/>
      <button @click="toggleSearch" class="btn-map search-captage"
              data-toggle="tooltip" data-placement="top" title="Rechercher un lieu">
              <i class="fa fa-search" aria-hidden="true"/>
      </button>
      <button @click="toggleBackgroundLayer" class="btn-map background"
              data-toggle="tooltip" data-placement="top" title="Changer la couche">
              <i class="fa fa-map" aria-hidden="true"/>
              <span class="background">{{ getBackgroundLayerIcon() }}</span>
      </button>
      <button @click="openLegend" class="btn-map legend"
              data-toggle="tooltip" data-placement="top" title="Ouvrir la légende">
              <i class="fa fa-list" aria-hidden="true" />
      </button>
      <button v-if="sidebarContent ==='tool'" @click="openFilesModal" class="btn-map files"
              data-toggle="tooltip" data-placement="top" title="Accéder aux fiches">
              <i class="fa fa-info-circle" aria-hidden="true" />
      </button>
      <button v-if="sidebarContent ==='diagnostic'" @click="createPermaLink" class="btn-map permaLink"
              data-toggle="tooltip" data-placement="top" title="Créér lien à partager">
              <i class="fa fa-link" aria-hidden="true" />
      </button>
      <button v-if="store.state.drawState.isDrawing === true && store.state.linesDrawn.length > 0" @click="undoDraw"
              class="btn-map undo-draw" data-toggle="tooltip" data-placement="top" title="Effacer des lignes">
              <i class="fa fa-undo" aria-hidden="true" />
      </button>
      <div id="modals"></div>
    </div>
</template>

<script lang="ts">
import { computed, defineComponent, onMounted, ref, watch } from 'vue';
import { GeoJSON } from "ol/format";
import { colors } from '@/utils/_colors';
import { ContentLegend } from "@/utils/_types";
import View from 'ol/View';
import { Fill, Stroke, Style, Text } from 'ol/style';
import CircleStyle from 'ol/style/Circle';
import 'ol-layerswitcher/dist/ol-layerswitcher.css';
import VectorSource from 'ol/source/Vector';
import { Vector as VectorLayer } from 'ol/layer';
import { useStore } from '@/store';
import Draw from "ol/interaction/Draw";
import { getLength } from 'ol/sphere';
import {Select} from "ol/interaction";
import Modal from "@c/Modal.vue";
import { click } from 'ol/events/condition';
import { useRouter } from "vue-router";
import { Geometry } from 'ol/geom';
import { initMapBackgroundLayer, orthoLayer, osmLayer, removeLayerByTitle } from './map';
import {fetchNominatim} from "@/api";
import {fromLonLat} from "ol/proj";

export default defineComponent({
  name: 'AppMap',
  components: {Modal},
  setup: () => {

    const router = useRouter()

    /**
    * STORE
    */
    const store = useStore();

    // watch
    watch(() => [store.state.drawState.isDrawing, store.state.selectedLayers, store.state.backgroundLayer],
        ([newIsDraw, newSelectedLayers, newBackgroundLayer], [oldIsDraw, oldSelectedLayers, oldBackgroundLayer]) => {
      newIsDraw != oldIsDraw && toggleDrawInteraction();
      newBackgroundLayer != oldBackgroundLayer && loadBackgroundLayer();
      if (newSelectedLayers != oldSelectedLayers) {
        store.commit('setModalState', {
          // !! selection of extra layers should not affect the isOpen state of the modal. So this property is not inversed here.
          isOpen: store.state.modalState.isOpen,
          type: 'legend',
          title: 'Légende de la carte',
          content: buildLegendContent()
        });
      }
    })

    watch(() => (store.state.selectedStationId), (current, old) => {
      if (null !== current) {
        stationsLayer.getSource()?.getFeatureById(current)?.setStyle(selectStationStyle);
        stationsZoneLayer.getSource()?.getFeatureById(current)?.setStyle(selectedStationZoneStyle);
      }
      if (null !== old) {
        stationsLayer.getSource()?.getFeatureById(old)?.setStyle(stationStyle);
        stationsZoneLayer.getSource()?.getFeatureById(old)?.setStyle(stationZoneStyle);
      }
    })

    // data
    const olMapDiv = ref('');

    // map styles
    const createTextStyle = (feature, resolution) =>
        new Text({
          font: '12px sans-serif',
          text: getText(feature, resolution),
          offsetX: 20,
          offsetY: -20,
          overflow: true,
          fill: new Fill({ color: 'black' }),
          stroke: new Stroke({ color: 'white', width: 2 }),
        });

    const stationStyle = (feature, resolution) => [
      new Style({
        image: new CircleStyle({
          radius: 6,
          fill: new Fill({
            color: '#ffffff',
          }),
          stroke: new Stroke({
            color: colors.blue,
            width: 2
          }),
        }),
      }),
      new Style({
        image: new CircleStyle({
          radius: 2,
          fill: new Fill({
            color: colors.blue
          }),
          stroke: new Stroke({
            color: colors.blue
          })
        }),
        text: createTextStyle(feature, resolution)
      }),
    ];

    const selectStationStyle = (feature, resolution) => [
      new Style({
        image: new CircleStyle({
          radius: 6,
          fill: new Fill({
            color: '#ffffff',
          }),
          stroke: new Stroke({
            color: colors.red,
            width: 2
          }),
        }),
      }),
      new Style({
        image: new CircleStyle({
          radius: 2,
          fill: new Fill({
            color: colors.red
          }),
          stroke: new Stroke({
            color: colors.red
          })
        }),
        text: createTextStyle(feature, resolution)
      }),
    ];

    const stationZoneStyle = (_feature, _resolution) =>
      new Style({
        stroke: new Stroke({
          color: colors.blue,
          width: 2,
          }),
        });

    const selectedStationZoneStyle = (_feature, _resolution) =>
       new Style({
        stroke: new Stroke({
          color: colors.red,
          width: 3,
          }),
        });

    // LAYERS
    const stationSource = new VectorSource({
      format: new GeoJSON(),
      url: '/api/stations'
    });
    const stationsLayer = new VectorLayer({
      source: stationSource,
      style: stationStyle,
      zIndex: 1001
    });

    const stationsZoneLayer = new VectorLayer({
      source: new VectorSource({
        format: new GeoJSON(),
        url: '/api/stations-zones',
      }),
      style: stationZoneStyle,
      visible: false,
      zIndex: 1000,
    });

    stationsLayer.set('station', true);
    stationsZoneLayer.set('station', true);

    const getText = (feature, resolution) =>
        resolution > 15 ? '' : feature.get('name');

    // methods
    const initMap = () => {
      const view = new View({
        center: store.state.currentCenter,
        zoom: store.state.currentZoom
      });

      store.state.map.setTarget(olMapDiv.value);
      store.state.map.setView(view);
      store.state.map.setLayers([stationsLayer, stationsZoneLayer, drawLayer]);
      initMapBackgroundLayer(store);
    };

    const toggleBackgroundLayer = () => {
      if (store.state.backgroundLayer === 'osm') {
        store.commit('setBackgroundLayer', 'ortho');
        removeLayerByTitle(store.state.map, 'osm');
      } else {
        if (store.state.backgroundLayer === 'ortho') {
          store.commit('setBackgroundLayer', null);
          removeLayerByTitle(store.state.map, 'ortho');
        } else {
          store.commit('setBackgroundLayer', 'osm');
        }
      }
    }

    const loadBackgroundLayer = () => {
      if (store.state.backgroundLayer === 'osm') {
        store.state.map.addLayer(osmLayer);
      } else {
        if (store.state.backgroundLayer === 'ortho') {
          store.state.map.addLayer(orthoLayer);
        } else {
          store.state.map.removeLayer(orthoLayer);
        }
      }
    };

    const getBackgroundLayerIcon = () => {
        if (store.state.backgroundLayer === 'osm') {
            return 'OSM'
            } else {
            if (store.state.backgroundLayer === 'ortho') {
                return 'ORTHO'
            } else {
                return 'NO'
            }
        }
    };

    const createPermaLink = () => {
      store.commit('setModalState', {
        isOpen: !store.state.modalState.isOpen,
        type: 'permaLink',
        title: 'Lien à partager',
        content: window.location.href
      });
    }

    const buildLegendContent = (): ContentLegend[] => {
      let contentLegend: ContentLegend[] = []
      if (store.state.selectedLayers.length > 0) {
        store.state.selectedLayers.forEach((layer, i) => {
          contentLegend[i] = {
            id: layer.id,
            name: layer.name,
            description: layer.description,
            type: layer.type,
            color: layer.style,
            imgURL: `${layer.data.split('?')[0]}?REQUEST=GetLegendGraphic&VERSION=1.0.0&FORMAT=image/png&WIDTH=20&HEIGHT=20&LAYER=${layer.data.split('?LAYERS=')[1]}`
          }
        })
      }

      return contentLegend;
    }

    let isSearch = ref(false);

    const toggleSearch = () => {
      isSearch.value = !isSearch.value;
    }

    const searchCaptage = (e) => {
      let coordinates: Array<number> = []

      fetchNominatim(e.target.value).then(response => {
        if (response?.length > 0) {
          coordinates = [parseFloat(response[0].lon), parseFloat(response[0].lat)]
          store.state.map.getView().setCenter(fromLonLat(coordinates, 'EPSG:3857'));
          store.state.map.getView().setZoom(15);
        }
      })

      isSearch.value = !isSearch.value;
    }

    const openLegend = () => {
      store.commit('setModalState', {
        isOpen: !store.state.modalState.isOpen,
        type: 'legend',
        title: 'Légende de la carte',
        content: buildLegendContent()
      });
    }

    const openFilesModal = () => {
      store.commit('setModalState', {
        isOpen: !store.state.modalState.isOpen,
        type: 'info-files',
        title: 'Fiches informatives',
        content: buildLegendContent()
      });
    }

    const addRouteParams = (zoom, center) => {
      const centerString = `${center[0]},${center[1]}`
      router.push({
        name: 'permalink',
        params: {
          zoom,
          center: centerString
        }
      })
    }

    // select station functionality
    const selectStationClick = new Select({
      style: selectStationStyle, //TODO do not unselect when clicking on the map,
      condition: click
    });

    const addInteraction = () => {
      store.state.map.removeInteraction(selectStationClick);
      store.state.map.addInteraction(selectStationClick);
      selectStationClick.on('select', (e) => {
        if (e.selected) {
          let featureSelected = e.selected[0];
          let layer = selectStationClick.getLayer(featureSelected);
          if (layer && layer?.get('station')) {
            const selectedStationId = featureSelected.getId();
            store.commit('setSelectedStationId', selectedStationId)
          }
        }
      });
    };

    // Detect manual zoom changes

    store.state.map.on('moveend', () => {
      const newZoom = store.state.map.getView().getZoom();
      const newCenter = store.state.map.getView().getCenter();
      store.commit('setCurrentZoom', newZoom);
      store.commit('setCurrentCenter', newCenter);

      if(store.state.sidebarContent !== 'tool') {
        addRouteParams(newZoom, newCenter);
      }

      if (undefined != newZoom && newZoom >= 12) {
        stationsZoneLayer.set('visible', true);
      }
      if (undefined != newZoom && newZoom < 12) {
        stationsZoneLayer.set('visible', false);
      }
    })

    // Draw functionality used in AOD
    const source = new VectorSource();

    const lineText = (feature) => new Text({
      font: '16px sans-serif',
      text: `${feature.get('title')}`,
      fill: new Fill({color: colors.green}),
      stroke: new Stroke({color: 'white', width: 3}),
    });

    const lineStyle = (feature) => new Style({
      stroke: new Stroke({
        color: colors.green,
        lineDash: [10, 10],
        width: 4,
      }),
      text: lineText(feature),
    })

    const axeStyle = new Style({
      stroke: new Stroke({
        color: colors["blue-trend"],
        width: 3,
      })
    })

    const zoneStyle = new Style({
      stroke: new Stroke({
        color: colors.red,
      })
    })

    const drawLayer = new VectorLayer({
      source: source,
      style: function(feature) {
        if (feature.get('name') === 'solutionLine') {
          return lineStyle(feature);
        } else {
          if (feature.get('name') === 'axeLine') {
            return axeStyle;
          } else {
            return zoneStyle;
          }
        }
      },
      zIndex: 1002
    });

    const getLineLength = (line: Geometry|undefined) => line ? getLength(line) : 0;

    const newLine = new Draw({
      source: source,
      type: 'LineString'
    });

    const newAxe = new Draw({
      source: source,
      type: 'LineString'
    })

    const newZone = new Draw({
      source: source,
      type: 'Polygon'
    })


    newLine.on('drawend', (e) => {
      const id = store.state.linesDrawn.filter(l => l.type === 'line').length + 1
      e.feature.setProperties({
        'name': 'solutionLine',
        'title': `ligne-${id}`
      })
      store.commit('setNewLine', {
        id: id,
        line: e.feature,
        type: 'line',
        length: getLineLength(e.feature.getGeometry())
      });
    });

    newAxe.on('drawend', e => {
      e.feature.setProperties({
        'name': 'axeLine'
      })
      store.commit('setNewLine', {
        id: `axe-${store.state.linesDrawn.filter(l => l.type === 'axe').length + 1}`,
        line: e.feature,
        type: 'axe',
        length: getLineLength(e.feature.getGeometry())
      });
      store.commit('setFlowLength', getLineLength(e.feature.getGeometry()));
    })

    const removeDrawInteraction = () => {
      store.state.map.getInteractions().forEach(
          i => {
              if ((i instanceof Draw) ) {
                  store.state.map.removeInteraction(i);
              }
          }
        )
    }

    document.addEventListener('keydown', e => {
      if (e.key === 'Escape') {
        store.commit('setDrawState', {isDrawing: false, type: ''});
      }
    });

    const toggleDrawInteraction = () => {
      if (store.state.drawState.isDrawing && store.state.drawState.type === 'lines') {
        store.state.map.addInteraction(newLine);
      } else {
        if (store.state.drawState.isDrawing && store.state.drawState.type === 'axe') {
          store.state.map.addInteraction(newAxe);
        } else {
          if (store.state.drawState.isDrawing && store.state.drawState.type === 'zone') {
            store.state.map.addInteraction(newZone);
          } else {
            removeDrawInteraction();
          }
        }
      }
    };

    const undoDraw = () => {
      const linesDrawn = drawLayer.getSource()?.getFeatures() ?? [];
      if (linesDrawn.length != 0) {
        const lastLine = linesDrawn[linesDrawn.length - 1];
        drawLayer.getSource()?.removeFeature(lastLine);
        store.commit('deleteLine', store.state.linesDrawn.length);
      }
    }

    document.addEventListener('keydown', (e) => {
      if (e.key === 'Backspace') {
        undoDraw();
      }
    })

    //lifecycle hooks
    onMounted(() => {
        initMap()
        addInteraction()
      }
    );

    return {
      store,
      olMapDiv,
      isSearch,
      createPermaLink,
      openLegend,
      openFilesModal,
      toggleSearch,
      searchCaptage,
      undoDraw,
      toggleBackgroundLayer,
      getBackgroundLayerIcon,
      backgroundLayer: computed(() => store.state.backgroundLayer),
      sidebarContent: computed(() => store.state.sidebarContent)
    }
  }
})
</script>

